// Copyright 2017 Darius Neatu (neatudarius@gmail.com)

#ifndef ALLOCATOR_H_
#define ALLOCATOR_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* un typedef de convenienta */
typedef struct {
    unsigned char *addr;
    int size;
} Arena;

int readAction(Arena *arena);
void INITIALIZE(Arena *arena, int n);
void FINALIZE(Arena *arena);
void DUMP(Arena *arena);
int ALLOC(Arena *arena, int size, int start);
void FREE(Arena *arena, int index);
void FILL(Arena *arena, int index, int size, unsigned char value);
void SHOW_FREE(Arena *arena);
void SHOW_USAGE(Arena *arena);
void SHOW_ALLOCATIONS(Arena *arena);
void SHOW_MAP(Arena *arena, int length);
int ALLOCALIGNED(Arena *arena, int size, int start, int align);
int REALLOC(Arena *arena, int index, int size);
void SET_INT(Arena *arena, int n, int value);
void SET_BYTE(Arena *arena, int n, unsigned char value);
int READ_INT(Arena *arena, int n);
unsigned char READ_BYTE(Arena *arena, int n);

#endif  // ALLOCATOR_H_
